var KeyCode = Java.type('javafx.scene.input.KeyCode');
var Vector = Java.type('cz.upol.scripting.game.Vector');

var sceneWidth = 500;
var sceneHeight = 330;
var blockSize = 20;

var inFlight = true;

function onInit()
{
	game.createElement('duke', 'duke', blockSize, 200, blockSize, blockSize);
	game.createElement('wall', 0, 0, sceneWidth, blockSize);
	game.createElement('wall', 0, sceneHeight, sceneWidth, blockSize);
	game.createElement('wall', 0, 0, blockSize, sceneHeight);
	game.createElement('wall', sceneWidth - blockSize, 0, blockSize, sceneHeight);
	
	game.createElement('wall', 320, 220, 180, blockSize);
	game.createElement('wall', 240, 160, 100, blockSize);
	game.createElement('wall', 400, 120, 100, blockSize);
	game.createElement('wall', 100, 80, 100, blockSize);
	game.createElement('wall', 0, 180, 100, blockSize);
	
	game.createElement('wood', 200, 80, 100, 10);
	game.createElement('wood', 240, 260, 80, 10);
	
	game.createElement('point', 20, 120, blockSize, blockSize);
	game.createElement('point', 140, 60, blockSize, blockSize);
	game.createElement('point', 460, 60, blockSize, blockSize);
	game.createElement('point', 460, 140, blockSize, blockSize);
	game.createElement('point', 360, 240, blockSize, blockSize);
}

function onKeyPressed(keyCode)
{
	if (!inFlight) {
		var duke = game.getById('duke');
		if (keyCode == KeyCode.SPACE) {
			duke.setSpeed(new Vector(duke.getSpeed().getX() / 2, -10));
			inFlight = true;
		}
		if (keyCode == KeyCode.LEFT) duke.setSpeed(new Vector(-10, 0));
		if (keyCode == KeyCode.RIGHT) duke.setSpeed(new Vector(10, 0));
	}
	
}

function onLoop()
{
	var elt = game.getById('duke');
	elt.speed = new Vector(elt.speed.x, elt.speed.y + 0.5);
	if (game.getByClass("point").isEmpty())
		game.completeGame("Congratulations !");
}


function onCollision(elt, obstacle, horizontal, vertical)
{
	if (elt.id == 'duke') {
		if (obstacle.elementClass == 'wall') return duke2wall(elt, obstacle, horizontal, vertical); 
		if (obstacle.elementClass == 'wood') return duke2wood(elt, obstacle, horizontal, vertical);
		if (obstacle.elementClass == 'point') obstacle.makeDisappear();
	}
	return 0;
}

function duke2wall(duke, wall, horizontal, vertical)
{
	var resolution = 0;
	if (vertical) {
		duke.speed = new Vector(duke.speed.x, 0);
		resolution |= game.DONT_MOVE_VERTICALLY;
		
		if (wall.y > duke.y) inFlight = false;
	}
	if (horizontal) {
		duke.speed = new Vector(0, duke.speed.y);
		resolution |= game.DONT_MOVE_HORIZONTALLY;
	}
	
	return resolution;
}

function duke2wood(duke, wood, horizontal, vertical)
{
	var resolution = 0;
	if (horizontal) {
		duke.speed = new Vector(0, duke.speed.y);
		resolution |= game.DONT_MOVE_HORIZONTALLY;
	}
	
	if (vertical) {
		duke.speed = new Vector(duke.speed.x, -duke.speed.y);
		resolution = game.RETRY;
		wood.makeDisappear();
		inFlight = true;
	}
	return resolution;
}
