package cz.upol.scripting;

import cz.upol.scripting.game.Element;
import javafx.animation.KeyValue;
import javafx.scene.shape.Rectangle;

/**
 * JavaFX komponenta zobrazujici nejaky element hry
 */
class ElementView extends Rectangle {
	
	private final Element element;
	
	/**
	 * Vytvori prislusny ovladaci prvek JavaFX
	 * 
	 * @param element -- element hry navazany na tento prvek
	 * @param styleClass -- CSS styl, jaky bude prirazen tomuto prvku
	 */
	public ElementView(Element element, String styleClass) {
		super(element.getWidth(), element.getHeight());
		this.element = element;
		this.setX(element.getX());
		this.setY(element.getY());
		this.getStyleClass().add(styleClass);
	}
	
	/**
	 * @return vraci pole hodnot pro Timeline, kde kazda hodnota udava, jak se ma zmenit
	 * nejak vlastnost objektu (predevsim souradnice x a y)
	 */
	public KeyValue[] getAnimationValues() {
		return new KeyValue[] {
				new KeyValue(this.xProperty(), element.getX()),
				new KeyValue(this.yProperty(), element.getY())
		};
	}

	public Element getElement() {
		return element;
	}
}