package cz.upol.scripting.game;

/**
 * Priznaky, jakymi lze vyresit kolizi dvou elementu herniho sveta {@link Element}
 */
public interface CollisionResolution {
	
	/** element se nebude pohybovat v horizontalnim smeru, ale pouze vertikalne */
	public final int DONT_MOVE_HORIZONTALLY = 1;
	
	/** element se nebude pohybovat ve vertikalnim smeru, ale pouze horizontalne */
	public final int DONT_MOVE_VERTICALLY = 2;
	
	/** element se nebude pohybovat vubec */
	public final int DONT_MOVE = 3;
	
	/** 
	 * algoritmus se detekovat kolize znovu,
	 * jelikoz doslo ke zmene nejakeho elementu v hernim svete 
	 */
	public final int RETRY = 4;
}
